(require [kodhy.macros [qw amap rmap map-dvals afind]])

(import
  re
  json
  [kodhy.util [T F slurp merge-dicts]])

(setv input-path "../AMLIB_SelectOptions.class.php")
(setv SEEKING (qw msf msm fsm fsf))

(setv source-lists (dfor
   [k v] (re.findall
     r"\ndefine\('LIST_(.+?)' *, *'(.+?)'\);"
     (slurp input-path))
   [(.lower k) (dfor
     [k2 v2] (re.findall r"(\d+)~(.+?)(?:\||\Z)" v)
     [(int k2) v2])]))

(setv out {})

(for [[list-name table-name] [["preferences" "OpenTo"] ["tastes" "TurnsMeOn"] ["desires" "LookingFor"]]]
  (setv ds (rmap [s SEEKING] (get source-lists (+ list-name "_" s))))
  (setv (get out table-name) (dict
    (rmap [code (sorted ((. (set) union) #* (amap (tuple (.keys it)) ds)))]
      (setv vals (amap (.get it code) ds))
      (, code (merge-dicts
        {"val" (afind it vals)}
        (dict (zip SEEKING (map bool vals)))))))))
;  (setv d (pd.DataFrame result :columns (qw code val msf msm fsm fsf)))
;  (setv d (.set-index d "code"))
;  (setv (get out table-name) d))

(setv (get out "seeking") (map-dvals
  (do
    (setv m (re.match "signup\.seekingvalue\.(.*?)(female|male)seeking(females|males)" it))
    (.strip (.format "{} {} seeking {}" (.group m 1) (.group m 2) (.group m 3))))
  (get source-lists "seeking")))

(for [s (qw gender smoking drinking)]
  (setv (get out s) (get source-lists s)))

(setv (get out "ethnicity") (get source-lists "ethnic"))

(with [o (open "amcodes.json" "wt")]
  (json.dump out o :sort_keys T :indent 2))
