(import
  csv
  sqlite3
  [cheat-importing.common [states]])

(setv input-path "/tmp/free-zipcode-database-Primary.csv")
  ; http://federalgovernmentzipcodes.us/free-zipcode-database-Primary.csv
(setv db-path "../data/zipstates.sqlite")

(setv db (sqlite3.connect db-path))
(.execute db "create table T (
    zipcode   integer primary key,
    state     integer not null)")

(with [o (open input-path)]
  (setv reader (csv.DictReader o))
  (for [line reader]
    (when (in (get line "State") states)
      (.execute db "insert into T (zipcode, state) values (?, ?)" (,
        (int (get line "Zipcode"))
        (.index states (get line "State")))))))

(.commit db)
(.execute db "vacuum")
